package brs.visitor;
import brs.*;
import tree.*;

/**
 * Transforming a binary tree to an n-ary Tree.
 * Problem 3 of exam 2.
 * @author DXN
 * @since April 13, 2006
 */
public class MakeTree implements IVisitor {
    public static final MakeTree Singleton = new MakeTree ();
    private MakeTree ()  {
    }

    /**
    * @param nu not used.
    * @return Tree an empty Tree.
    */
    public Object emptyCase(BiTree host, Object... nu) {
        return new Tree();  
    }

    /**
    * @param nu not used.
    * @return Tree equivalent to host.
    */
    public Object nonEmptyCase (BiTree host, Object... nu)  {
        Tree t = new Tree();  // create a new empty tree
        t.insertRoot(host.getRootDat());  // insert root data       
        // recursively build the right sibling of the left subtree:
        Tree rs = (Tree)host.getRightSubTree().execute(this);          
        // recursively build the left most child:        
        Tree lmc = (Tree)host.getLeftSubTree().execute(Helper.Singleton, rs);          
        t.set_leftMostChild(lmc);  // et the left most child tree.
        return t;
    }
}

class Helper implements IVisitor {
    public static final Helper Singleton = new Helper ();
    private Helper ()  {
    }

    /**
    * @param sib Tree the right sibling
    * @return Tree the right sibling is now the left most child.
    */
    public Object emptyCase(BiTree h, Object... sib) {
        return sib[0];  
    }

    /**
    * @param sib Tree the right sibling of the host h.
    * @return Tree equivalent to host.
    */
    public Object nonEmptyCase (BiTree h, Object... sib)  {
        Tree t = new Tree();  // create a new empty tree
        t.insertRoot(h.getRootDat());  // insert root data
        t.set_rightSibling((Tree)sib[0]);  //  set the rightsibling Tree        
        // recursively build the right sibling of the left subtree:
        Tree rs = (Tree)h.getRightSubTree().execute(MakeTree.Singleton);          
        // recursively build the left most child:
        Tree lmc = (Tree)h.getLeftSubTree().execute(this, rs);        
        t.set_leftMostChild(lmc);  //  set the left most child.
        return t;
    }
}
