package lrs.visitor;
import lrs.*;

/**
 * Problem 1.c.
 * Check to see if the host is a palindrome.
 * 10 pts total
 */
public class IsPalin2 implements IAlgo {
    public static final IsPalin2 Singleton = new IsPalin2();
    private IsPalin2() {}
    
    public Object emptyCase(LRStruct host, Object... nu) {
        return true;  
    }
    
    public Object nonEmptyCase(final LRStruct host, Object... nu) {
        // look for a helper visitor here.
        // should not use if to check for emptiness:
        return host.getRest().execute(new IAlgo() {
            
            // one-element list case
            public Object emptyCase(LRStruct h, Object... nu) {  
                return true;
            }
            
            // there are at least two elements in host
            public Object nonEmptyCase(LRStruct h, Object... nu) {
                // Can also remove last from host, but this takes an extra step
                // since we know already that host if followed by a non-empty list, h.
                if(host.getFirst().equals(h.execute(RemLast.Singleton))) {
                    // Could also have recursed on host.getRest() instead of h 
                    return h.execute(IsPalin2.this);
                }
                else {
                    return false;
                }
            }          
        });
    }
}