package lrs.visitor;
import lrs.*;

/**
 * Check to see if the host and the input contain equal elements in the same order.
 */
public class LRSEqual implements IAlgo {
    public static final LRSEqual Singleton = new LRSEqual();
    private LRSEqual() {}
    
    public Object emptyCase(LRStruct host, Object... other) {
        return ((LRStruct)other[0]).execute(new IAlgo() {
            public Object emptyCase(LRStruct otherHost, Object... nu) {
                return true;
            }
            public Object nonEmptyCase(LRStruct otherHost, Object... nu) {
                return false;
            }
        });
    }
    
    public Object nonEmptyCase(final LRStruct host, Object... other) {
        return ((LRStruct)other[0]).execute(new IAlgo() {
            public Object emptyCase(LRStruct otherHost, Object... nu) {
                return false;
            }
            public Object nonEmptyCase(LRStruct otherHost, Object... nu) {
                if(host.getFirst().equals(otherHost.getFirst())) {
                    return host.getRest().execute(LRSEqual.this, otherHost.getRest());
                }
                else {
                    return false;
                }
            }
        });
    }
}